"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.map = exports.fold = exports.isSuccess = exports.isFailure = exports.isLoading = exports.isInitialized = exports.success = exports.failure = exports.pending = exports.initialized = void 0;
var initialized = function () { return ({ tag: 'Initialized' }); };
exports.initialized = initialized;
var pending = function () { return ({ tag: 'Pending' }); };
exports.pending = pending;
var failure = function (error) { return ({ tag: 'Failure', error: error }); };
exports.failure = failure;
var success = function (data) { return ({ tag: 'Success', data: data }); };
exports.success = success;
var isInitialized = function (rd) { return rd.tag === 'Initialized'; };
exports.isInitialized = isInitialized;
var isLoading = function (rd) { return rd.tag === 'Pending'; };
exports.isLoading = isLoading;
var isFailure = function (rd) { return rd.tag === 'Failure'; };
exports.isFailure = isFailure;
var isSuccess = function (rd) { return rd.tag === 'Success'; };
exports.isSuccess = isSuccess;
var fold = function (initialized, pending, failure, success) {
    return function (_) {
        switch (_.tag) {
            case 'Initialized':
                return initialized();
            case 'Pending':
                return pending();
            case 'Failure':
                return failure(_.error);
            case 'Success':
                return success(_.data);
            default:
                throw new TypeError('RemoteData case not matched');
        }
    };
};
exports.fold = fold;
var map = function (f, fa) { return (0, exports.isSuccess)(fa) ? (0, exports.success)(f(fa.data)) : fa; };
exports.map = map;
//# sourceMappingURL=rd.js.map