import { DocumentNode, OperationVariables, QueryResult } from '@apollo/client';
import { RemoteData } from './rd';
export declare type QueryResultWithRemoteData<T, V = OperationVariables> = QueryResult<T, V> & {
    _rd: RemoteData<T>;
};
/**
 * @description Maps a `useQuery` QueryResult to the appropriate RemoteData discriminant
 * @param query DocumentNode
 * @param vars Query variables
 * @returns Everything from `QueryResult` with an accompanying `_rd` property wth the RemoteData object
 */
export declare const useQueryRd: <T, V = OperationVariables>(query: DocumentNode, vars?: V | undefined) => QueryResultWithRemoteData<T, V>;
//# sourceMappingURL=useQueryRd.d.ts.map